/*****************************************************************************
   Copyright (C) 2006 NTT
  *****************************************************************************/
/**
 * @file    CompRemoteLSN.h
 * @brief   ローカル・リモートLSN比較に関する定数の定義
 *
 * ローカル・リモートLSN比較に使用する定数を定義する。
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#ifndef COMPREMOTELSN_H_
#define COMPREMOTELSN_H_

/*****************
 * 定数定義
 ****************/
/**
 * @def     CC_CMDFMT_PSQL
 * @brief   PostgreSQL接続コマンド生成用フォーマット
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define CC_CMDFMT_PSQL	"psql -h %s -l"

/**
 * @def     CC_COMMANDMAX_PSQL
 * @brief   PostgreSQL接続コマンド文字列最大長
 *
 * @attention 16という値は、コマンド生成用フォーマット内の可変部(%s)以外の文字列の長さを表す。
 *            コマンドを修正する場合は、値に注意すること。
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define CC_COMMANDMAX_PSQL	PREX_MAX_HOSTNAME_LEN + 16

/** 
 * @def     CC_GETREMOTELSN_POLLING_INTERVAL
 * @brief   LSNリモート値を取得失敗時のポーリング間隔
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define CC_GETREMOTELSN_POLLING_INTERVAL	10

/**
 * @def     ARGINDEX_HOST
 * @brief   ホスト名を示すargv[]のインデックス
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define ARGINDEX_HOST	1

/**
 * @def     ARGINDEX_USER
 * @brief   ユーザ名を示すargv[]のインデックス
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define ARGINDEX_USER	2

#endif /* COMPREMOTELSN_H_ */
