/*****************************************************************************
   Copyright (C) 2006 NTT
  *****************************************************************************/
/** 
 * @file    WaitSyncXLOG.h
 * @brief   XLOG同期完了待ち処理に関する定数の定義
 *
 * XLOG同期完了待ち処理に使用する定数を定義する。
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#ifndef WAITSYNCXLOG_H_
#define WAITSYNCXLOG_H_

/*****************
 * 定数定義
 ****************/
/**
 * @def     ARGINDEX_PORT
 * @brief   ポート番号を示すargv[]のインデックス
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define ARGINDEX_PORT	1

/*****************
 * マクロ関数定義
 ****************/
/**
 * @def     WaitSyncXLOG_FREE()
 * @brief   後処理（生成したソケットの解放）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WaitSyncXLOG_FREE() { \
  if (acc != FD_INACTIVE) { \
    shutdown(acc, SHUT_RDWR); \
    close(acc); \
  } \
  acc = FD_INACTIVE; \
  if (sock != FD_INACTIVE) { \
    shutdown(sock, SHUT_RDWR); \
    close(sock); \
  } \
  sock = FD_INACTIVE; \
}

#endif /* WAITSYNCXLOG_H_ */
