/*****************************************************************************
   Copyright (C) 2006-2007 NTT
  *****************************************************************************/
/** 
 * @file    msgact.h
 * @brief   ACT化要求／応答メッセージ送受信処理に関する定数の定義
 *
 * ACT化要求／応答メッセージ送受信処理に使用する定数を定義する。
 *
 * @version 1.1.0
 * @date    08/07/2007
 * @since   1.0
 */
#ifndef MSGACT_H_
#define MSGACT_H_

/*****************
 * 定数定義
 ****************/
/**
 * @def     ARGINDEX_MSGQKEY
 * @brief   メッセージキューのキー値を示すargv[]のインデックス
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define ARGINDEX_MSGQKEY	1

/**
 * @def     ARGINDEX_LOGID
 * @brief   LSNのログIDを示すargv[]のインデックス
 *
 * @version 1.1.0
 * @date    08/07/2007
 * @since   1.0
 */
#define ARGINDEX_LOGID	2

/**
 * @def     ARGINDEX_OFFSET
 * @brief   LSNのオフセットを示すargv[]のインデックス
 *
 * @version 1.1.0
 * @date    08/07/2007
 * @since   1.0
 */
#define ARGINDEX_OFFSET	3

/**
 * @def     DELAY_USEC
 * @brief   待ち時間（マイクロ秒）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define DELAY_USEC	0

/**
 * @def     DELAY_SEC
 * @brief   待ち時間（秒）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define DELAY_SEC	3

#endif /* MSGACT_H_ */
