/*****************************************************************************
   Copyright (C) 2006 NTT
  *****************************************************************************/
/** 
 * @file    prexsyslog.h
 * @brief   SYSLOGメッセージ出力処理に関する定数の定義
 *
 * SYSLOGメッセージ出力処理に使用する定数を定義する。
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#ifndef PREXSYSLOG_H_
#define PREXSYSLOG_H_

/*****************
 * 定数定義
 ****************/
/**
 * @def     ARGINDEX_MSGLEVEL
 * @brief   メッセージレベルを示すargv[]のインデックス
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define ARGINDEX_MSGLEVEL	1

/**
 * @def     ARGINDEX_MSGCODE
 * @brief   メッセージコードを示すargv[]のインデックス
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define ARGINDEX_MSGCODE	2

/**
 * @def     ARGINDEX_FILE
 * @brief   ファイル名を示すargv[]のインデックス
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define ARGINDEX_FILE	3

/**
 * @def     ARGINDEX_LINE
 * @brief   行番号を示すargv[]のインデックス
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define ARGINDEX_LINE	4
/**
 * @def     ARGINDEX_MSGSTR1
 * @brief   埋め込み文字（１つ目）を示すargv[]のインデックス
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define ARGINDEX_MSGSTR1	5
/**
 * @def     ARGINDEX_MSGSTR2
 * @brief   埋め込み文字（２つ目）を示すargv[]のインデックス
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define ARGINDEX_MSGSTR2	6

#endif /* PREXSYSLOG_H_ */
