#!/bin/sh
#####################################################################
# Copyright   : Copyright (C) 2006-2007 NTT
#/**
# * @file    acttestsql.sh
# * @brief   データベーステーブルチェック処理
# *
# * データベーステーブルへのチェック処理を行う。
# *
# *   詳細は以下のとおり。
# *     -# データベーステーブルへのチェック処理を行う。
# *        エラーがあった場合、syslogにメッセージを出力後（prexsyslogコマンド）、戻り値としてRET_NGを返却して終了する。
# *     -# 戻り値としてRET_OKを返却して終了する。
# *
# * @note        本スクリプトは、運用管理者がデータベーステーブルチェック処理を直接記述し、カスタマイズすることができる。
# * @retval      RET_OK(0)     正常終了
# * @retval      RET_NG(1)     異常終了
# *
# * @version 1.1.0
# * @date    08/09/2007
# * @since   1.0
# */

# DEFINE値取り込み
. ${HOME}/prex/bin/prexdefine.sh

# データベーステーブルチェック処理 (例)
psql postgres -c "select * from pg_catalog.pg_tables"

[ ${?} -ne ${RET_OK} ] && exit ${RET_NG}
exit ${RET_OK}
