#!/bin/sh
#####################################################################
# Copyright   : Copyright (C) 2006-2008 NTT
#/**
# * @file    prexdefine.sh
# * @brief   Clusterコマンド 共通変数定義
# *
# * Clusterコマンドで共通的に使用する変数の定義を行う。
# *
# *   詳細は以下のとおり。
# *     -# 変数を定義する。
# *
# * @version 1.3.0
# * @date    06/17/2008
# * @since   1.0
# */

# ユーザ名とホームディレクトリパスを環境変数に定義（運用管理者が環境に合わせて定義する）
PREX_USER="prexuser"
PREX_HOME="/home/${PREX_USER}"
PREX_BIN="${PREX_HOME}/prex/bin"

# デバッグログ出力の有無
DEBUG_LOG='OFF'

# 戻り値
RET_OK=0
RET_NG=1
RET_LOCAL_ADVANCED=2
RET_REMOTE_ADVANCED=3
RET_SAME_XLOG=4
RET_ERR_GREP=2
RET_GREP_NOTFOUND=1
RET_LOCK=2
RET_ERROR=3
RET_NOTEXISTS=7
OCF_SUCCESS=0
OCF_ERR_GENERIC=1
OCF_NOT_RUNNING=7

# ログ種別
LOG_ERR=3
LOG_WARNING=4
LOG_INFO=6
LOG_DEBUG=6

# 定数
wwconffile=${PREX_HOME}/prex/WALWriter.conf
prex_lock_dir=${PREX_HOME}/prex/lock
defalutkey=7890
postmaster_lock_file=/tmp/.s.PGSQL.*.lock
postmaster_pid_file=${PGDATA}/postmaster.pid
recoveryconf_file=${PGDATA}/recovery.conf
recoverydone_file=${PGDATA}/recovery.done
walsegment_dir=${PGDATA}/pg_xlog
CMDNAME_GREP='grep'
CMDNAME_HEARTBEAT='/etc/init.d/heartbeat'
CMDNAME_CRMSTANDBY='/usr/sbin/crm_standby'
PNAME_POSTMASTER='postgres'
PNAME_POSTGRES_BGWRITER='postgres: writer process'
PNAME_POSTGRES_RECOVERY='postgres: startup process'
PNAME_WALWriter='WALWriter'
PNAME_SBYMONITOR='sbymonitor.sh'
PNAME_MSGACT='msgact'
PNAME_CHECK_ENABLE_TOACT='check_enable_toact.sh'
PNAME_SLEEP='sleep'
PARAM_INIT=-i
ENVITEM_MSGKEY='prex_msgkey'
FILE_NAME_EXCLUSIVE=${prex_lock_dir}/exclusive_lock
FILE_NAME_ACT=${prex_lock_dir}/prex_act_lock
FILE_NAME_SBY=${prex_lock_dir}/prex_sby_lock
FILE_NAME_FO=${prex_lock_dir}/prex_fo_lock
##<-200806
FILE_NAME_HISTORY=${walsegment_dir}/LASTLSNHISTORYFILE
##->200806

ACT_LOCK_COMMANDID=3
SBY_LOCK_COMMANDID=5
FO_LOCK_COMMANDID=7
FILE_SET='file_set'
FILE_GET='file_get'
FILE_RM='file_rm'
MONITOR_TYPEID_LOCK=1
MONITOR_TYPEID_UNLOCK=0
FO_TYPEID_LOCK=1
FO_TYPEID_UNLOCK=0
SMG_OPEN_COMMAND=1
SMG_UNLINK_COMMAND=2
LASTWAL_RETRY=3             # LastWALによる終端LSNの取得に失敗した場合のリトライ回数
LASTWAL_RETRY_INTERVAL=0.5  # LastWALによる終端LSNの取得に失敗した場合のリトライ待機間隔

# メッセージ一覧
. ${PREX_BIN}/prexmessage.sh
