#!/bin/sh
#####################################################################
# Copyright   : Copyright (C) 2006-2008 NTT
#/**
# * @file    prexmessage.sh
# * @brief   FMS-IF、Clusterコマンド syslog出力用文字列定義（メッセージID・埋め込み文字）
# *
# * 下記の機能で、syslog出力に使用するメッセージIDと埋め込み文字の定義を行う。
# *  - FMS-IF
# *  - Clusterコマンド
# *
# *   詳細は以下のとおり。
# *     -# 変数を定義する。
# *
# * @version 1.3.0
# * @date    06/17/2008
# * @since   1.0
# */

##
## 高可用化ソフトウェアインタフェース
##
MSGID_HAIF_ILLEGALPARAM='00900001'
MSGID_HAIF_FAILEDTOOPENFILE='00900003'
MSGID_HAIF_FAILEDTOGET='00900010'
MSGID_HAIF_FAILEDTOACT='00900026'
MSGID_HAIF_ERRORACTMONITOR='00900027'
MSGID_HAIF_ERRORSBYMONITOR='00900029'
MSGID_HAIF_ERRORSBYSTATUS='00900030'
MSGID_HAIF_ERRORGREP='00900032'
MSGID_HAIF_FAILEDTOSTOPPROCESS='00900041'
MSGID_HAIF_FAILEDTOSTOPPREX='00900048'
MSGID_HAIF_ILLEGALSTATEOFACT='00900065'
MSGID_HAIF_DEBUG='00600000'                # デバッグ用メッセージ

##
## Clusterコマンド
##
MSGID_CC_ILLEGALPARAM='01900001'
MSGID_CC_FAILEDTOACCESSFILE='01900002'
MSGID_CC_FAILEDTOOPENFILE='01900003'
MSGID_CC_FAILEDTOFOUNDMSGQ='01900005'
MSGID_CC_FAILEDTODELETEMSGQ='01900006'
MSGID_CC_FAILEDTOCREATEMSGQ='01900007'
MSGID_CC_FAILEDTORECV='01900012'
MSGID_CC_FAILEDTOSBY='01900028'
MSGID_CC_ERRORGREP='01900032'
MSGID_CC_FAILEDTOCOMPREMOTELSN='01900033'
MSGID_CC_FAILEDTOACTMSGSENDRECV='01900034'
MSGID_CC_FAILEDTOSYNCXLOG='01900035'
MSGID_CC_FAILEDTOWAITSYNCXLOG='01900036'
MSGID_CC_WARNINGFAILEDTOPGSTOP='01900037'
MSGID_CC_FAILEDTOFOUNDPROCESS='01900038'
MSGID_CC_FAILEDTOBOOTPROCESS='01900040'
MSGID_CC_FAILEDTOSTOPPROCESS='01900041'
MSGID_CC_FAILEDTOSTOPPREX='01900048'
MSGID_CC_FAILEDTOREADCONFIG='01900050'
MSGID_CC_ERRORSQLCHECK='01900054'
MSGID_CC_WARNINGNOPROCESS='01900061'
MSGID_CC_FAILEDTOGET='01900010'           # 値の取得に失敗
MSGID_CC_DEBUG='01600000'                 # デバッグ用メッセージ

##
## 共通関数
##
MSGID_CMN_ILLEGALPARAM='10900001'
MSGID_CMN_FAILEDTOACCESSFILE='10900002'
MSGID_CMN_FAILEDTOOPENFILE='10900003'
MSGID_CMN_FAILEDTOWRITEFILE='10900004'
MSGID_CMN_FAILEDTODELETEFILE='10900009'
MSGID_CMN_FAILEDTOCTLLOCK='10900058'
MSGID_CMN_DEBUG='10600000'                        # デバッグ用メッセージ

##
## FMS-IF
##
MSGID_FMSIF_ERRORSTATENOTMATCH='11900073'         # PREXの状態不適合
MSGID_FMSIF_ERRORRECOVERYFILENOTEXISTS='11900075' # recovery.confファイルが存在しない
MSGID_FMSIF_ERRORRECOVERYFILERENAME='11900076'    # recovery.confファイルのリネームに失敗
MSGID_FMSIF_ERRORGETMSGKEY='11900008'             # メッセージキューのキー値取得に失敗
MSGID_FMSIF_ERRORTOSBY='11900077'                 # SBY化要求が異常終了
MSGID_FMSIF_ERRORTOACT='11900090'                 # ACT化要求が異常終了
MSGID_FMSIF_ERRORSTOPIMMEDIATE='11900074'         # 強制停止要求が異常終了
MSGID_FMSIF_ERROREXCLUSION='11900072'             # 抑止ファイルの設定に失敗
MSGID_FMSIF_ERRORSEMAPHORE='11900086'             # セマフォ管理コマンドが異常終了
MSGID_FMSIF_FAILEDTOCOMPREMOTELSN='11900033'      # ローカル・リモートLSN比較が異常終了
MSGID_FMSIF_FAILEDTOSYNCXLOG='11900035'           # XLOG同期に失敗
MSGID_FMSIF_FAILEDTOWAITSYNCXLOG='11900036'       # XLOG動機待ちに失敗
MSGID_FMSIF_FAILEDTOREADCONFIG='11900050'         # 設定ファイルの読み込みに失敗
MSGID_FMSIF_ERRORDELETEFILE='11900084'            # ファイルの削除に失敗
MSGID_FMSIF_ERRORLSNREMOTEADVANTAGE='11900085'    # リモートホストのLSNが先行
MSGID_FMSIF_PREXONSTANDBY='11800087'              # PREXのSBY化に成功
MSGID_FMSIF_ERRORNETWORK='11900088'               # リモートホストとの通信に失敗
MSGID_FMSIF_FOCONTROLDONE='11900089'              # フェールオーバ抑止を実行
MSGID_FMSIF_INVALIDSTATUS='11900091'              # 無効なステータス
MSGID_FMSIF_DEBUG='11600000'                      # デバッグ用メッセージ
##<-200806
MSGID_FMSIF_FAILEDTODELETEFILE='11900009'         # ファイルの削除失敗
MSGID_FMSIF_FAILEDTOGET='11900010'                # 値の取得失敗
MSGID_FMSIF_FAILEDTOCREATE='11900011'             # ファイルの作成失敗
##->200806

##
## 運用コマンド
##
MSGID_UTIL_ILLEGALPARAM='12900001'                # 無効なパラメータ
MSGID_UTIL_FAILEDTOGET='12900010'                 # 値の取得に失敗
MSGID_UTIL_FAILEDTOREADCONFIG='12900050'          # 設定ファイルの読み込みに失敗
MSGID_UTIL_ERRORNETWORK='12900088'                # リモートホストとの通信に失敗
MSGID_UTIL_ERRORSTATENOTMATCH='12900073'          # PREXの状態不適合
MSGID_UTIL_ERRORPSQL='12900092'                   # psqlコマンドが異常終了
MSGID_UTIL_XLOGSYNCTIMEOUT='12900093'             # XLOG同期完了待ちがタイムアウト
MSGID_UTIL_ERRORHASTOP='12900094'                 # 高可用化ソフトウェアの停止指示に失敗
MSGID_UTIL_ERRORHASWITCHOVER='12900095'           # 高可用化ソフトウェアのスイッチオーバ指示に失敗
MSGID_UTIL_DEBUG='12600000'                       # デバッグ用メッセージ

##
## 付加情報
##
MSGWD_INIT_OPTION='-i_option'
MSGWD_ENVITEM_MSGKEY='EnvItem(prex_msgkey)'
MSGWD_PREXSBYMONITORLOCK1='prex_sbymonitor_lock1'
MSGWD_PREXSBYMONITORLOCK2='prex_sbymonitor_lock2'
MSGWD_WWCONFIGFILE='WALWriter.conf'
MSGWD_RECOVERYCONFFILE='recovery.conf'
MSGWD_RECOVERYDONEFILE='recovery.done'
MSGWD_QMSG_REPRYTOSBY='result_of_go-standby_message'
MSGWD_POSTMASTER='postmaster'
MSGWD_POSTGRES_BGWRITER='postgres(BGwriter)'
MSGWD_POSTGRES_RECOVERY='postgres(recovery)'
MSGWD_WALWRITER='WALWriter'
MSGWD_NUMOFPARAM='number_of_parameters'
MSGWD_INVALIDPARAM='invalid_parameter'
MSGWD_LASTLSN_LOCAL='LAST-LSN(local)'
MSGWD_LASTLSN_REMOTE='LAST-LSN(remote)'
MSGWD_TIMELINEID_LOCAL='TIME-LINE-ID(local)'
MSGWD_TIMELINEID_REMOTE='TIME-LINE-ID(remote)'
