/*****************************************************************************
   Copyright (C) 2006 NTT
  *****************************************************************************/
/**
 * @file    GetCheckPointLSNFromBackupLabel.h
 * @brief   backup_labelからのチェックポイントLSN取得に関する定数の定義
 * 
 * backup_labelからのチェックポイントLSN取得に使用する定数を定義する。
 *
 * @version 0.0.0
 * @date    10/20/2006
 * @since   1.0
 */
#ifndef GETCHECKPOINTLSNFROMBACKUPLABEL_H_
#define GETCHECKPOINTLSNFROMBACKUPLABEL_H_

/*****************
 * 定数定義
 ****************/
/**
 * @def     CMN_PATH_BACKUPLABEL
 * @brief   backup_labelのパス
 *
 * @attention パス生成用フォーマット内の可変部(%s)にはグローバル変数 g_WWEnvInfo.sbybackupdir が代入される。
 * @version 1.0.0
 * @date    10/27/2006
 * @since   1.0
 */
#define CMN_PATH_BACKUPLABEL	"%s/backup_label"

/**
 * @def     CMN_CMD_GETCHECKPOINTLSNFROMBACKUPLABEL
 * @brief   backup_labelからのチェックポイントLSN取得コマンド
 *
 * @attention コマンド生成用フォーマット内の可変部(%s)にはCMN_PATH_BACKUPLABELによって生成されたbackup_labelのパスが代入される。
 * @version 1.0.0
 * @date    10/27/2006
 * @since   1.0
 */
#define CMN_CMD_GETCHECKPOINTLSNFROMBACKUPLABEL	"grep '^START WAL LOCATION:' %s | sed 's/^START WAL LOCATION:[ ]*\\(.*\\)(.*)$/\\1/g'"

/**
 * @def     CMN_COMMANDMAX_GETCHECKPOINTLSNFROMBACKUPLABEL
 * @brief   backup_labelからのチェックポイントLSN取得コマンドの最大長
 *
 * @attention 128という値は、コマンド生成用フォーマット内の可変部(%s)以外の文字列の長さを表す。
 *            コマンドを修正する場合は、値に注意すること。
 * @version 1.0.0
 * @date    10/27/2006
 * @since   1.0
 */
#define CMN_COMMANDMAX_GETCHECKPOINTLSNFROMBACKUPLABEL	PREX_MAX_PATH_LEN + 128

/*******************
 * プロトタイプ宣言
 ******************/
int GetCheckPointLSNFromBackupLabel(LSNInfo_t* pCheckPointLSN);

#endif /* GETCHECKPOINTLSNFROMBACKUPLABEL_H_ */
