/*****************************************************************************
   Copyright (C) 2006-2007 NTT
  *****************************************************************************/
/**
 * @file    ReadWWConfFile.h
 * @brief   WALWriter用設定ファイルの読み込みに関するテーブル及び定数の定義
 *
 * WALWriter用設定ファイルの読み込みに使用するテーブル及び定数を定義する。
 *
 * @version 1.1.0
 * @date    08/02/2007
 * @since   1.0
 */
#ifndef READWWCONFFILE_H_
#define READWWCONFFILE_H_

/*****************
 * 定数定義
 ****************/
/**
 * @def     WW_CONF_FILE
 * @brief   WALWriter用設定ファイル名
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_CONF_FILE  "WALWriter.conf"

/**
 * @def     READ_FILE_SIZE
 * @brief   読み込み行格納先バッファサイズ
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define READ_FILE_SIZE    512

/**
 * @def     WW_ITEM_WS_HOST
 * @brief   設定ファイル項目名（ws_host）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_WS_HOST    "ws_host"

/**
 * @def     WW_ITEM_PREX_PORT
 * @brief   設定ファイル項目名（prex_port）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_PREX_PORT    "prex_port"

/**
 * @def     WW_ITEM_WS_POLLING_INTERVAL
 * @brief   設定ファイル項目名（ws_polling_interval）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_WS_POLLING_INTERVAL    "ws_polling_interval"

/**
 * @def     WW_ITEM_WW_BUFFERS
 * @brief   設定ファイル項目名（ww_buffers）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_WW_BUFFERS    "ww_buffers"

/**
 * @def     WW_ITEM_PREX_MSGKEY
 * @brief   設定ファイル項目名（prex_msgkey）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_PREX_MSGKEY    "prex_msgkey"

/**
 * @def     WW_ITEM_ACTWALHOST
 * @brief   設定ファイル項目名（actwalhost）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_ACTWALHOST    "actwalhost"

/**
 * @def     WW_ITEM_ACTARCHIVEHOST
 * @brief   設定ファイル項目名（actarchivehost）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_ACTARCHIVEHOST    "actarchivehost"

/**
 * @def     WW_ITEM_ACTBACKUPHOST
 * @brief   設定ファイル項目名（actbackuphost）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_ACTBACKUPHOST    "actbackuphost"

/**
 * @def     WW_ITEM_ACTWALUSER
 * @brief   設定ファイル項目名（actwaluser）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_ACTWALUSER    "actwaluser"

/**
 * @def     WW_ITEM_ACTARCHIVEUSER
 * @brief   設定ファイル項目名（actarchiveuser）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_ACTARCHIVEUSER    "actarchiveuser"

/**
 * @def     WW_ITEM_ACTBACKUPUSER
 * @brief   設定ファイル項目名（actbackupuser）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_ACTBACKUPUSER    "actbackupuser"

/**
 * @def     WW_ITEM_ACTWALDIR
 * @brief   設定ファイル項目名（actwaldir）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_ACTWALDIR    "actwaldir"

/**
 * @def     WW_ITEM_ACTARCHIVEDIR
 * @brief   設定ファイル項目名（actarchivedir）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_ACTARCHIVEDIR    "actarchivedir"

/**
 * @def     WW_ITEM_ACTBACKUPDIR
 * @brief   設定ファイル項目名（actbackupdir）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_ACTBACKUPDIR    "actbackupdir"

/**
 * @def     WW_ITEM_SBYWALDIR
 * @brief   設定ファイル項目名（sbywaldir）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_SBYWALDIR    "sbywaldir"

/**
 * @def     WW_ITEM_SBYARCHIVEDIR
 * @brief   設定ファイル項目名（sbyarchivedir）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_SBYARCHIVEDIR    "sbyarchivedir"

/**
 * @def     WW_ITEM_SBYBACKUPDIR
 * @brief   設定ファイル項目名（sbybackupdir）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_SBYBACKUPDIR    "sbybackupdir"

/**
 * @def     WW_ITEM_PREX_VIRTUAL_IP
 * @brief   設定ファイル項目名（prex_virtual_ip）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define WW_ITEM_PREX_VIRTUAL_IP    "prex_virtual_ip"

/**
 * @def     WW_ITEM_ACTHAHOST
 * @brief   設定ファイル項目名（acthahost）
 *
 * @version 1.1.0
 * @date    08/02/2007
 * @since   1.0
 */
#define WW_ITEM_ACTHAHOST    "acthahost"

/**
 * @def     KEEPALIVES_IDLE
 * @brief   設定ファイル項目名（keepalives_idle）
 *
 * @version 1.1.0
 * @date    08/02/2007
 * @since   1.0
 */
#define WW_ITEM_KEEPALIVES_IDLE    "keepalives_idle"

/**
 * @def     DKEEPALIVES_INTERVAL
 * @brief   設定ファイル項目名（keepalives_interval）
 *
 * @version 1.1.0
 * @date    08/02/2007
 * @since   1.0
 */
#define WW_ITEM_KEEPALIVES_INTERVAL    "keepalives_interval"

/**
 * @def     KEEPALIVES_COUNT
 * @brief   設定ファイル項目名（keepalives_count）
 *
 * @version 1.1.0
 * @date    08/02/2007
 * @since   1.0
 */
#define WW_ITEM_KEEPALIVES_COUNT    "keepalives_count"

/**
 * @def     WW_ITEM_ENABLETOACTRETRYCOUNT
 * @brief   設定ファイル項目名（enabletoactretrycount）
 *
 * @version 1.1.0
 * @date    10/30/2007
 * @since   1.0
 */
#define WW_ITEM_ENABLETOACTRETRYCOUNT    "enabletoactretrycount"

/**
 * @def     WW_ITEM_ENABLETOACTRETRYINTERVAL
 * @brief   設定ファイル項目名（enabletoactretryinterval）
 *
 * @version 1.1.0
 * @date    10/30/2007
 * @since   1.0
 */
#define WW_ITEM_ENABLETOACTRETRYINTERVAL    "enabletoactretryinterval"

/**
 * @def     MAX_WW_HOSTNAME_LEN
 * @brief   WALWriter設定ファイルで指定されるホスト名の最大バイトサイズ
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define MAX_WW_HOSTNAME_LEN    128

/**
 * @def     MAX_WW_USERNAME_LEN
 * @brief   WALWriter設定ファイルで指定されるユーザ名の最大バイトサイズ
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define MAX_WW_USERNAME_LEN    64

/**
 * @def     MAX_WW_PATH_LEN
 * @brief   WALWriter設定ファイルで指定されるディレクトリパスの最大バイトサイズ
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define MAX_WW_PATH_LEN    256

/**
 * @def     MAX_WW_IP_LEN
 * @brief   WALWriter設定ファイルで指定されるIPアドレス文字列の最大バイトサイズ
 *
 * @version 1.0.0
 * @date    08/01/2007
 * @since   1.1
 */
#define MAX_WW_IP_LEN    15


/**
 * @def     MIN_WW_BUFFERS
 * @brief   WALWriter設定ファイルで指定されるWALWriter用WALバッファの最小値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define MIN_WW_BUFFERS    8192

/**
 * @def     MIN_WW_ITEMVAL_LEN
 * @brief   WALWriter設定ファイルで指定される文字列項目の長さの有効最小値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define MIN_WW_ITEMVAL_LEN    1

/**
 * @def     MIN_WW_POSNUM_ITEMVAL
 * @brief   WALWriter設定ファイルで指定可能な正数値項目の最小値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define MIN_WW_POSNUM_ITEMVAL    1

/**
 * @def     MIN_WW_UINT_ITEMVAL
 * @brief   WALWriter設定ファイルで指定可能な unsigned int 項目の最小値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define MIN_WW_UINT_ITEMVAL    0

/* 設定項目の初期値 */
/**
 * @def     DEF_SIGNED_NUM_VALUE
 * @brief   WALWriter用設定項目（数値（signed）項目）の初期値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define DEF_SIGNED_NUM_VALUE    -1

/**
 * @def     DEF_UNSIGNED_NUM_VALUE
 * @brief   WALWriter用設定項目（数値（unsigned）項目）の初期値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define DEF_UNSIGNED_NUM_VALUE    0xFFFFFFFF

/**
 * @def     DEF_CHAR_VALUE
 * @brief   WALWriter用設定項目（文字列項目）の初期値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define DEF_CHAR_VALUE    NULL

/**
 * @def     DEF_WS_POLLING_INTERVAL
 * @brief   WALWriter用設定項目（WALSenderへのポーリング間隔（秒））の初期値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define DEF_WS_POLLING_INTERVAL    1


/**
 * @def     DEF_WW_BUFFERS
 * @brief   WALWriter用設定項目（WALWriter用WALバッファのブロック数）の初期値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define DEF_WW_BUFFERS    MIN_WW_BUFFERS

/**
 * @def     DEF_PREX_MSGKEY
 * @brief   WALWriter用設定項目（メッセージキューのキー値）の初期値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define DEF_PREX_MSGKEY    7890

/**
 * @def     DEF_ACTWALDIR
 * @brief   WALWriter用設定項目（ACT側WALセグメント格納ディレクトリ）の初期値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define DEF_ACTWALDIR    "/usr/local/pgsql/data/pg_xlog"

/**
 * @def     DEF_SBYWALDIR
 * @brief   WALWriter用設定項目（SBY側WALセグメント格納ディレクトリ）の初期値
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define DEF_SBYWALDIR    "/usr/local/pgsql/data/pg_xlog"

/**
 * @def     DEF_ENABLETOACTRETRYCOUNT
 * @brief   WALWriter用設定項目（ACT化可否チェックの試行回数）の初期値
 *
 * @version 1.1.0
 * @date    10/30/2007
 * @since   1.1
 */
#define DEF_ENABLETOACTRETRYCOUNT    0

/**
 * @def     DEF_ENABLETOACTRETRYINTERVAL
 * @brief   WALWriter用設定項目（ACT化可否チェックの試行間隔）の初期値
 *
 * @version 1.1.0
 * @date    10/30/2007
 * @since   1.1
 */
#define DEF_ENABLETOACTRETRYINTERVAL    0

/**
 * @def     CHAR_RETURN
 * @brief   文字（'\n'）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define CHAR_RETURN    '\n'

/**
 * @def     CHAR_SHARP
 * @brief   文字（'#'）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define CHAR_SHARP    '#'

/**
 * @def     CHAR_EQUAL
 * @brief   文字（'='）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define CHAR_EQUAL    '='

/**
 * @def     CHAR_SPACE
 * @brief   文字（' '）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define CHAR_SPACE    ' '

/**
 * @def     CHAR_TAB
 * @brief   文字（'\t'）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define CHAR_TAB    '\t'

/**
 * @def     CHAR_NUL
 * @brief   文字（'\0'）
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define CHAR_NUL    '\0'

/**
 * @enum    WWItemType_t
 * @brief   設定項目タイプ
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
typedef enum WWItemType_t {
	WW_ITEMTYPE_INVALID=-1,
	WW_ITEMTYPE_CHAR,
	WW_ITEMTYPE_NUM_UNSIGNED,
	WW_ITEMTYPE_NUM_SIGNED,
} WWItemType_t;

/**
 * @enum    WWItemID_t
 * @brief   設定項目
 *
 * @version 1.1.0
 * @date    10/30/2007
 * @since   1.0
 */
typedef enum WWItemID_t {
	WW_ITEMID_INVALID=-1,
	WW_ITEMID_WS_HOST,
	WW_ITEMID_PREX_PORT,
	WW_ITEMID_WS_POLLING_INTERVAL,
	WW_ITEMID_WW_BUFFERS,
	WW_ITEMID_PREX_MSGKEY,
	WW_ITEMID_ACTWALHOST,
	WW_ITEMID_ACTARCHIVEHOST,
	WW_ITEMID_ACTBACKUPHOST,
	WW_ITEMID_ACTWALUSER,
	WW_ITEMID_ACTARCHIVEUSER,
	WW_ITEMID_ACTBACKUPUSER,
	WW_ITEMID_ACTWALDIR,
	WW_ITEMID_ACTARCHIVEDIR,
	WW_ITEMID_ACTBACKUPDIR,
	WW_ITEMID_SBYWALDIR,
	WW_ITEMID_SBYARCHIVEDIR,
	WW_ITEMID_SBYBACKUPDIR,
	WW_ITEMID_PREX_VIRTUAL_IP,
	WW_ITEMID_ACTHAHOST,
    WW_ITEMID_FO_CONTROLFILE,
	WW_ITEMID_KEEPALIVES_IDLE,
	WW_ITEMID_KEEPALIVES_INTERVAL,
	WW_ITEMID_KEEPALIVES_COUNT,
	WW_ITEMID_ENABLETOACTRETRYCOUNT,
	WW_ITEMID_ENABLETOACTRETRYINTERVAL
} WWItemID_t;

/**
 * @enum    LineType_t
 * @brief   設定ファイル行タイプ
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
typedef enum LineType_t {
	LINETYPE_ERROR=0,
	LINETYPE_EMPTY,
	LINETYPE_COMMENT,
	LINETYPE_CONF,
	LINETYPE_OTHER
} LineType_t;

/*****************
 * テーブル定義
 ****************/
/**
 * @struct  WWSettingItem_t
 * @brief   設定項目情報
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
typedef struct WWSettingItem_t {
	WWItemID_t    nID;            ///< 設定項目ID
	WWItemType_t  nType;          ///< 設定項目種別
	char*         pName;          ///< 設定項目名
} WWSettingItem_t;

/**
 * @struct  WWSettingInfo_t
 * @brief   設定ファイル項目情報
 *
 * @version 1.1.0
 * @date    10/30/2007
 * @since   1.0
 */
typedef struct WWSettingInfo_t {
	char*		ws_host;						///< WALSenderが稼動するホスト
	int			prex_port;						///< WALSender接続ポート番号
	int			ws_polling_interval;			///< WALSenderへの接続要求ポーリング間隔
	int			ww_buffers;						///< WALWriter用WALバッファにおけるブロック数
	int			prex_msgkey;					///< 使用するメッセージキューのキー値
	char*		actwalhost;						///< 転送対象WALディレクトリを持つACT側ホスト
	char*		actarchivehost;					///< 転送対象アーカイブログディレクトリを持つACT側ホスト
	char*		actbackuphost;					///< 転送対象バックアップディレクトリを持つACT側ホスト
	char*		actwaluser;						///< actwalhostで指定したホストへのログインユーザ名
	char*		actarchiveuser;					///< actarchivehostで指定したホストへのログインユーザ名
	char*		actbackupuser;					///< actbackuphostで指定したホストへのログインユーザ名
	char*		actwaldir;						///< ACT側WALディレクトリ
	char*		actarchivedir;					///< ACT側アーカイブログディレクトリ
	char*		actbackupdir;					///< ACT側ベースバックアップディレクトリ
	char*		sbywaldir;						///< SBY側WALディレクトリ
	char*		sbyarchivedir;					///< SBY側アーカイブログディレクトリ
	char*		sbybackupdir;					///< SBY側ベースバックアップディレクトリ
	char*		prex_virtual_ip;				///< PREXが稼動するサーバの仮想IPアドレス
	char*		acthahost;						///< ACT側ホストの高可用化ソフトウェア用通信ノード
	int         keepalives_idle;                ///< WALSenderとのTCP通信における通信断の確認を開始するまでの間隔
	int         keepalives_interval;            ///< WALSenderとのTCP通信において、通信断の確認を行う間隔
	int         keepalives_count;               ///< WALSenderとのTCP通信において、通信断の確認を行う回数
	int         enabletoactretrycount;          ///< WALWriterで通信異常を検知した時のACT化可否チェックの試行回数
	int         enabletoactretryinterval;       ///< WALWriterで通信異常を検知した時のACT化可否チェックの試行間隔
} WWSettingInfo_t;

/*******************
 * プロトタイプ宣言
 ******************/
int ReadConfigFile(char* pPath, WWSettingInfo_t* pEnvInfo);
LineType_t GetConfLineType (char* bufLine);
int SetEnvInfoFromLine(WWSettingInfo_t* pEnvInfo, char* bufLine);
int CheckConfigurationStatus(WWSettingInfo_t* pEnvInfo);
int InitSettingInfo(WWSettingInfo_t* pEnvInfo);
void TermSettingInfo(WWSettingInfo_t* pEnvInfo);

/*****************
 * マクロ関数定義
 ****************/
/**
 * @define  SetIntegerEnvItemGE(int* pRet__, int* pTrgt__, int inval__, int minval__, char* name__) 
 * @brief   設定ファイル項目情報（数値項目）の取得
 *
 * 指定された数値の範囲チェックを行い、適切であれば設定項目値として取得する。
 *
 * 詳細は、以下の通り。
 *     -# 入力値（inval__）が、指定された有効最小値（minval__）以上の場合、
 *        値の設定先（pTrgt__）に入力値（inval__）を設定し、戻り値（pRet__）に
 *        RET_OK を設定する。
 *     -# 入力値（inval__）が、指定された有効最小値（minval__）未満の場合、
 *        syslog にエラーメッセージを出力し（OutputSyslog 関数）、戻り値（pRet__）に
 *        RET_NG を設定する。
 *
 * @param[out]  pRet__      戻り値の格納先
 * @param[out]  pTrgt__     取得した設定値の格納先
 * @param[in]   inval__     入力値
 * @param[in]   minval__    有効な最小値
 * @param[in]   name__      対象の設定項目名
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define SetIntegerEnvItemGE(pRet__, pTrgt__, inval__, minval__, name__) { \
	if ((inval__) >= (minval__)) { \
		*(pTrgt__) = (inval__); \
		*(pRet__)  = RET_OK; \
	} else { \
		OutputSyslog(LOG_ERR, MSGID_CMN_ILLEGALPARAM, (name__)); \
		*(pRet__) = RET_NG; \
	} \
}

/**
 * @define  SetStringEnvItem(int* pRet__, char** pTrgt__, char* inval__, int minlen__, int maxlen__, char* name__)
 * @brief   設定ファイル項目情報（文字列項目）の取得
 *
 * 指定された文字列の長さチェックを行い、適切であれば設定項目値として取得する。
 *
 * 詳細は、以下の通り。
 *     -# 入力文字列（inval__）が NULL ではなく、かつその長さが指定された有効範囲
 *        （minlen__ 以上 maxlen__以下）内である場合、2～3 を実行する。
 *        それ以外の場合は、4 を実行する。
 *     -# 設定値の格納先（pTrgt__）にデフォルト値が設定されている場合、
 *        その格納領域を解放する。
 *     -# 入力文字列を複製し、設定値の格納先に設定して、戻り値（pRet__）に RET_OK
 *        を設定する。エラー発生時は、syslog にエラーメッセージを出力し
 *        （OutputSyslog 関数）、戻り値（pRet__）に RET_NG を設定する。
 *     -# syslog にエラーメッセージを出力し（OutputSyslog 関数）、戻り値（pRet__）に
 *        RET_NG を設定する。
 *
 * @param[out]  pRet__      戻り値の格納先
 * @param[out]  pTrgt__     取得した設定値の格納先
 * @param[in]   inval__     入力値
 * @param[in]   minlen__    inval__ の長さの有効な最小値
 * @param[in]   maxlen__    inval__ の長さの有効な最大値
 * @param[in]   name__      対象の設定項目名
 *
 * @version 1.0.0
 * @date    09/01/2006
 * @since   1.0
 */
#define SetStringEnvItem(pRet__, pTrgt__, inval__, minlen__, maxlen__, name__) \
	if (((inval__) != NULL) && \
		(strlen((inval__)) >= (minlen__)) && (strlen((inval__)) <= (maxlen__))) { \
		if (*(pTrgt__) != NULL) { \
			free(*(pTrgt__)); \
		} \
		*(pTrgt__) = strdup((inval__)); \
		if (*(pTrgt__) == NULL) { \
			OutputSyslog(LOG_ERR, MSGID_CMN_FAILEDTOALLOCMEM); \
			*(pRet__) = RET_NG; \
		} else { \
			*(pRet__) = RET_OK; \
		} \
	} else { \
		OutputSyslog(LOG_ERR, MSGID_CMN_ILLEGALPARAM, name__); \
		*(pRet__) = RET_NG; \
	}

#endif /* READWWCONFFILE_H_ */
