/*****************************************************************************
   Copyright (C) 2006-2007 NTT
  *****************************************************************************/
/**
 * @file    PREXMessage.c
 * @brief   PREX共通メッセージ定義
 *
 * PREXにおけるモジュール間で、共通に使用するメッセージを定義する。
 *
 * @version 1.1.0
 * @date    08/09/2007
 * @since   1.0
 */
#include "PREXMessage.h"

/************************************************
 * グローバル変数定義
 ***********************************************/
MessageInfo_t PREXMsgInfo[] = {
	{"00000", "%s", "Debug"},
	{"00001", "invalid parameter \"%s\"", "Error"},
	{"00002", "could not access file \"%s\"", "Error"},
	{"00003", "could not open file \"%s\"", "Error"},
	{"00004", "could not write file \"%s\"", "Error"},
	{"00005", "message queue does not exist", "Error"},
	{"00006", "could not remove message queue", "Error"},
	{"00007", "could not create message queue", "Error"},
	{"00008", "could not get message queue identifier", "Error"},
	{"00009", "could not delete file \"%s\"", "Error"},
	{"00010", "could not get \"%s\"", "Error"},
	{"00011", "could not create %s", "Error"},
	{"00012", "could not receive %s", "Error"},
	{"00013", "received data \"%s\" is invalid", "Error"},
	{"00014", "failed to compress function", "Error"},
	{"00015", "failed to decompress function", "Error"},
	{"00016", "%s本体部分割受信エラーです", "Error"},
	{"00017", "received data \"%s\" is \"NG\"", "Error"},
	{"00018", "could not send %s", "Error"},
	{"00019", "could not transfer from %s", "Error"},
	{"00020", "%sフラグの更新に失敗しました", "Error"},
	{"00021", "接続エラーです", "Error"},
	{"00022", "connection is closed", "Error"},
	{"00023", "connection timed out", "Error"},
	{"00024", "could not accept connection", "Error"},
	{"00025", "could not bind or listen socket", "Error"},
	{"00026", "could not activate correctly", "Error"},
	{"00027", "could not get status of active node", "Error"},
	{"00028", "could not go standby correctly", "Error"},
	{"00029", "could not get status of standby node", "Error"},
	{"00030", "could not get whether status of node is standby", "Error"},
	{"00031", "could not request HA software for status of node", "Error"},
	{"00032", "grep command returned error", "Error"},
	{"00033", "CompRemoteLSN command returned error", "Error"},
	{"00034", "msgact command returned error", "Error"},
	{"00035", "SyncXLOG command returned error", "Error"},
	{"00036", "WaitSyncXLOG command returned error", "Error"},
	{"00037", "could not execute immediate shutdown of PostgreSQL", "Warning"},
	{"00038", "%s process does not exist", "Error"},
	{"00039", "不正なプロセスが存在しています(%s)", "Error"},
	{"00040", "could not execute %s process", "Error"},
	{"00041", "could not terminate %s process", "Error"},
	{"00042", "%sスレッドの起動に失敗しました", "Error"},
	{"00043", "ssh接続エラーです", "Error"},
	{"00044", "ssh切断エラーです", "Error"},
	{"00045", "WALSender process exited with unexpected status", "Error"},
	{"00046", "WALセグメントファイルが1つも存在しません", "Error"},
	{"00047", "該当サービスが見つかりませんでした", "Error"},
	{"00048", "could not halt PREX", "Error"},
	{"00049", "could not attach to shared memory", "Error"},
	{"00050", "could not read configuration file", "Error"},
	{"00051", "ソケットオプションの設定エラーです", "Error"},
	{"00052", "could not create socket", "Error"},
	{"00053", "ソケットのバインドエラーです", "Error"},
	{"00054", "database check command returned error", "Error"},
	{"00055", "バックアップ取得エラーです", "Error"},
	{"00056", "could not allocate memory", "Error"},
	{"00057", "リソース確保に失敗しました", "Error"},
	{"00058", "could not control locking", "Error"},
	{"00059", "ロック制御に失敗しました", "Error"},
	{"00060", "共有メモリ領域へのアタッチに失敗しました", "Error"},
	{"00061", "%s process does not exist: start a new one", "Warning"},
	{"00062", "activation takes %d seconds or more", "Warning"},
	{"00063", "could not sync remote files: retry after %d seconds", "Warning"},
	{"00064", "received activation message before syncing WAL", "Error"},
	{"00065", "status must not be active: halt PREX", "Error"},
	{"00066", "log archive command failed: return code %d", "Error"},
	{"00067", "database system is ready in prex mode", "Information"},
	{"00068", "executed %s process", "Information"},
	{"00069", "local status now set from \"%s\" to \"%s\"", "Information"},
	{"00070", "invalid WAL segment", "Error"},
	{"00071", "received message, but it is not activation message", "Warning"},
	{"00072", "exclusion command returned error", "Error"},
	{"00073", "the state of PREX is incompatible to the state transition", "Error"},
	{"00074", "tostop_immediate command returned error", "Error"},
	{"00075", "recovery.conf file or recovery.done file is not exists", "Error"},
	{"00076", "could not rename to recovery.conf", "Error"},
	{"00077", "tosby command returned error", "Error"},
	{"00078", "could not open semaphore \"%s\" (%s)", "Error"},
	{"00079", "could not close semaphore \"%s\" (%s)", "Error"},
	{"00080", "could not unlink semaphore \"%s\" (%s)", "Error"},
	{"00081", "could not lock semaphore: command_id = \"%d\" (%s)", "Error"},
	{"00082", "could not unlock semaphore: command_id = \"%d\" (%s)", "Error"},
	{"00083", "%s file was created", "Debug"},
	{"00084", "%s file was deleted", "Debug"},
	{"00085", "LSN of the remote host is advantage", "Error"},
	{"00086", "Semaphore command returned error", "Error"},
	{"00087", "PREX on standby (mode \"%s\")", "Information"},
	{"00088", "impossible to connect a remote host \"%s\"", "Error"},
	{"00089", "PREX status change to ACT became invalid because of FO control", "Warning"},
	{"00090", "toact command returned error", "Error"},
	{"00091", "status value specified at the control file is invalid (type = \"%s\", value = \"%s\")", "Error"},
	{"00092", "psql command returned error", "Error"},
	{"00093", "synchronous waiting of xlog did the time-out", "Error"},
	{"00094", "heartbeat command returned error (host = \"%s\")", "Error"},
	{"00095", "crm_standby command returned error", "Error"},
	{"00096", "Acquisition of the LAST-LSN was failed (%s)", "Error"},
	{"00097", "could not access directory \"%s\" (%s)", "Error"},
	{"00098", "no file exists \"%s\"", "Error"},
	{"00099", "illegal file \"%s\" (%s)", "Error"},
	{"00100", "failed to compress WAL (%s)", "Error"},
	{"00101", "failed to decompress WAL (%s)", "Error"}
};	/* メッセージ情報 */

FunctionInfo_t PREXFuncInfo[] = {
	{"00", "HA software resource agent"},
	{"01", "PREX cluster commands"},
	{"02", "postmaster"},
	{"03", "postgres"},
	{"04", "postgres (recovery mode)"},
	{"05", "WALSender"},
	{"06", "WALWriter (communication thread)"},
	{"07", "WALWriter (writer thread)"},
	{"08", "WALWriter (message thread)"},
	{"09", "WALWriter (backup getting thread)"},
	{"10", "PREX common modules"},
	{"11", "FMS interface"},
	{"12", "Utility"}
};	/* 発生箇所（機能）情報 */
